unit demomain;

{
 Copyright (c) 1998 by Verisoft AG, Switzerland.

 Author: Wolfgang Rohdewald


 Disclaimer:
 This demo project is distributed as Freeware. There is no charge or warranty
 whatsoever. The author will not be held responsible for any direct or indirect
 damage resulting from the use of the component or any derivatives thereof.
 In short: USE IT AT YOUR OWN RISK! You are allowed to include the component
 code in any commercial or non commercial product. You are also allowed to make
 as many copies of the component as you want and distribute them, as long as you
 do not receive any money for the copying/distribution.

 You can send any comments, suggestions and bugs to wr@poboxes.com.
}

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ExtCtrls, VIdle;

const
	MaxIdleMinutes = 1;

type
	TfrmMain = class(TForm)
		IdleTimer: TVIdleTimer;
		lbIdle: TLabel;
		lbIdle2: TLabel;
		procedure IdleTimerTimer(Sender: TObject);
	private
		{ Private-Deklarationen }
		IdleDialog: TForm;
		IdleTimeShown: TDateTime;
		ShowingLogin: Boolean;
		savelast: TDateTime;
	public
		{ Public-Deklarationen }
	end;

var
	frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.IdleTimerTimer(Sender: TObject);
	function IdleMessage: String;
	begin
		Result := 'You did nothing for '
				+ IntToStr(IdleTimer.IdleMinutes)
				+ ' minutes'#13#10
				+ 'between '
				+ DateTimeToStr(IdleTimer.LastActivity)
				+ ' and '
				+ DateTimeToStr(Now) + #13#10
				+ 'Please log out after work.';
	end;
	procedure NewIdleDialog;
	begin
		savelast := IdleTimer.LastActivity;
// here is a problem: If the mouse is within the region where the modal
// dialog is created, the mouse callback fires and the IdleTime is
// reset. That is why we save/restore the last activity
// while creating the dialog.
		IdleDialog := CreateMessageDialog(IdleMessage,mtError,[mbOK]);
	end;
begin
	inherited;
	if savelast <> 0 then begin
		IdleTimer.LastActivity := savelast;
		savelast := 0;
	end;
	lbIdle.Caption := 'No user activity since '
				+ IntToStr(IdleTimer.IdleMinutes) + ' minutes';
	lbIdle2.Caption := 'No user activity since '
				+ TimeToStr(IdleTimer.IdleTime);
	if IdleTimer.IdleMinutes < MaxIdleMinutes then Exit;
	if ShowingLogin then Exit;
	if Assigned(IdleDialog) and (IdleTimer.IdleTime > IdleTimeShown) then begin
		(IdleDialog.FindComponent('Message') as TLabel).Caption := IdleMessage;
		Exit;
	end;
	NewIdleDialog;
	with IdleDialog do begin
		ShowModal;
		Free;
	end;
	IdleDialog := nil;
	IdleTimeShown := 0;
	ShowingLogin := True;
	try
		// here you could close all forms
		// and make him login again
		ShowMessage('this could be a login form');
	finally
		ShowingLogin := False;
	end;
end;

end.
